# File automatically generated by build.rs.
# Changes made to this file will not be saved.
from typing import List, Tuple, Any, Optional, Union, ClassVar


def read_hlpb(path: str) -> HlpbData: ...


class HlpbData:
    major_version: int
    minor_version: int
    aim_constraints: list[AimConstraintData]
    orient_constraints: list[OrientConstraintData]

    def __init__(
        self,
        major_version: int = 1,
        minor_version: int = 0,
    ) -> None: ...
    
    def save(self, path: str) -> None: ...


class AimConstraintData:
    name: str
    aim_bone_name1: str
    aim_bone_name2: str
    target_bone_name1: str
    target_bone_name2: str
    aim_type1: str
    aim_type2: str
    unk1: int
    unk2: int
    aim: list[float]
    up: list[float]
    quat1: list[float]
    quat2: list[float]

    def __init__(
        self,
        name: str,
        aim_bone_name1: str,
        aim_bone_name2: str,
        target_bone_name1: str,
        target_bone_name2: str,
        aim_type1: str = 'Default',
        aim_type2: str = 'Default',
        unk1: int = 0,
        unk2: int = 0,
        aim: list[float] = [1.0, 0.0, 0.0],
        up: list[float] = [0.0, 1.0, 0.0],
        quat1: list[float] = [0.0, 0.0, 0.0, 1.0],
        quat2: list[float] = [0.0, 0.0, 0.0, 1.0]
    ) -> None: ...


class OrientConstraintData:
    name: str
    parent_bone_name1: str
    parent_bone_name2: str
    source_bone_name: str
    target_bone_name: str
    unk_type: int
    constraint_axes: list[float]
    quat1: list[float]
    quat2: list[float]
    range_min: list[float]
    range_max: list[float]

    def __init__(
        self,
        name: str,
        parent_bone_name1: str,
        parent_bone_name2: str,
        source_bone_name: str,
        target_bone_name: str,
        unk_type: int,
        constraint_axes: list[float],
        quat1: list[float] = [0.0, 0.0, 0.0, 1.0],
        quat2: list[float] = [0.0, 0.0, 0.0, 1.0],
        range_min: list[float] = [-180.0, -180.0, -180.0],
        range_max: list[float] = [180.0, 180.0, 180.0]
    ) -> None: ...
